﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.SharePoint;
using Telerik.JustMock;
using System.Diagnostics;
using Telerik.JustMock.Helpers;

namespace JustMockSharePointSamples.ComponentsTests
{
	/// <summary>
	/// Summary description for UnitTest1
	/// </summary>
	[TestClass]
	public class SPContextTests
	{
		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

        //[TestMethod]
        //[ExpectedException(typeof(ApplicationException))]
        //public void Current_NotAvailable_ThrowsApplicationException()
        //{
        //    // Arrange
        //    Mock.Arrange(() => SPContext.Current).Throws(new ApplicationException("Not allowed to call SPContext.Current"));

        //    // Act
        //    SPContext currentContext = SPContext.Current;
        //}
		
        //[TestMethod]
        //public void Current_CurrentContextIsFake_ReturnsFakeSPContext()
        //{
        //    // Arrange
        //    var fakeContext = Mock.Create<SPContext>();
        //    Mock.Arrange(() => SPContext.Current).Returns(fakeContext);

        //    // Act
        //    SPContext currentContext = SPContext.Current;

        //    // Assert
        //    Assert.IsNotNull(currentContext, "The current SPContext should not be null");
        //}

        //[TestMethod]
        //public void SPWeb_AllowAnonymousAccess_ReturnsTrue()
        //{
        //    // Arrange
        //    var fakeContext = Mock.Create<SPContext>();
        //    Mock.Arrange(() => fakeContext.Web.AllowAnonymousAccess).Returns(true);

        //    // Assert
        //    Assert.IsTrue(fakeContext.Web.AllowAnonymousAccess, "Our SPWeb should allow anonymous access");
        //}

        //[TestMethod]
        //public void CurrentWeb_AllowAnonymousAccess_ReturnsTrue()
        //{
        //    // Arrange
        //    Mock.Arrange(() => SPContext.Current.Web.AllowAnonymousAccess).Returns(true);

        //    // Assert
        //    Assert.IsTrue(SPContext.Current.Web.AllowAnonymousAccess, "Anonymous access should be allowed on our current SPWeb");
        //}


        [TestMethod]
        public void ShouldAssertCustomFakeListItem()
        {
            var spWeb = Mock.Create<SPWeb>();
            var spList = Mock.Create<SPList>();
            var spListCollection = Mock.Create<SPListCollection>();

            IList<SPListItem> items = new List<SPListItem>();

            var id = Guid.NewGuid();

            items.Add(CreateEntity(id, "Telerik", "Support", "IT"));

            Mock.Arrange(() => spList.Items).ReturnsCollection(items);
            Mock.Arrange(() => spWeb.Lists).Returns(spListCollection);
            Mock.Arrange(() => spListCollection[Arg.AnyString]).Returns(spList);

            foreach (SPListItem item in spWeb.Lists["myList"].Items)
                Assert.AreEqual(id, item["ID"]);
           
            // uncomment only if you are using Q1 2011 build
            //Assert.AreEqual(1, spWeb.Lists["myList"].Items.Count);
        }

         private SPListItem CreateEntity(Guid id, string name, string department, string division)  
         {  
             var fakeItem = Mock.Create<SPListItem>(); 
 
             Mock.Arrange(() => fakeItem["ID"]).Returns(id);
             Mock.Arrange(() => fakeItem["Name"]).Returns(name);
             Mock.Arrange(() => fakeItem["Department"]).Returns(department);
             Mock.Arrange(() => fakeItem["Division"]).Returns(division);  
           
             return fakeItem;      
         }


        //[TestMethod]
        //public void CurrentWeb_VerboseSetupAllowAnonymousAccess_ReturnsTrue()
        //{
        //    // Arrange
        //    var fakeContext = Mock.Create<SPContext>();
        //    Mock.Arrange(() => SPContext.Current).Returns(fakeContext);

        //    var fakeWeb = Mock.Create<SPWeb>();
        //    Mock.Arrange(() => fakeContext.Web).Returns(fakeWeb);
        //    Mock.Arrange(() => fakeWeb.AllowAnonymousAccess).Returns(true);

        //    // Assert
        //    Assert.IsTrue(SPContext.Current.Web.AllowAnonymousAccess, "Anonymous access should be allowed on our current SPWeb");
        //}


        //[TestMethod]
        //public void Should_Assert_FakingOfSpList()
        //{
        //    var spWeb = Mock.Create<SPWeb>();
        //    var spList = Mock.Create<SPList>();

        //    var spListCollection = Mock.Create<SPListCollection>();
        //    var spListItemCollection = Mock.Create<SPListItemCollection>();

        //    Mock.Arrange(() => spWeb.Lists).Returns(spListCollection);
        //    Mock.Arrange(() => spListCollection[Arg.AnyString]).Returns(spList);

        //    Mock.Arrange(() => spList.GetItems(Arg.IsAny<SPQuery>())).Returns(spListItemCollection);

        //    Assert.AreEqual(spListCollection, spWeb.Lists);
        //    Assert.AreEqual(spList, spWeb.Lists["myList"]);
        //    Assert.AreEqual(spListItemCollection, spWeb.Lists["myList"].GetItems(new SPQuery()));
        //}

	}
}
